function AddHelperInfoOnHover() {
   var allElements = document.getElementsByTagName("*");

   for (var i = 0; i < allElements.length; i++) {
      e = allElements[i];
      if (e.getAttributeNode("helper")) {
         if(e.addEventListener)
         {
            e.addEventListener("mouseover", DisplayHelp);
            e.addEventListener("mouseout", HideHelp);
            e.helper = document.createElement("div");
            e.helper.innerHTML = e.getAttributeNode("helper").value;
            e.helper.className = "helper";
            this.document.body.appendChild(e.helper);
         }
         else
         {
            break;
         }
      }
   }
}

function DisplayHelp() {
   pos = findPos(this);
   this.helper.style.left = this.offsetWidth + 10 + pos[0] + "px";
   this.helper.style.top = pos[1] + "px";
   this.helper.style.visibility = "visible";
   this.helper.style.opacity = 1;
}

function HideHelp() {
   this.helper.style.opacity = 0;
   this.helper.style.visibility = "hidden";
}

function findPos(obj) {
   var curleft = curtop = 0;
   if (obj.offsetParent) {
      do {
         curleft += obj.offsetLeft;
         curtop += obj.offsetTop;
      } while (obj = obj.offsetParent);
   }
   return [curleft, curtop];
}

AddHelperInfoOnHover();