function Signal()
{
   this.valid;
   this.cpValid;
   this.dpValid;
   this.channel;
   this.prn;
   this.measType;
   this.halfCycleAdj;
   this.cphQuality ;
   this.cno;
   this.cycleSlipCount;
   this.pseudorange;
   this.carrierPhase;
   this.doppler;
   this.constType;
}

function GPSDataStore() {
    this.PRN = null;
    this.COLUMN_L1CA_RANGE = null;
    this.COLUMN_L1CA_PHASE = null;
    this.COLUMN_L1CA_DOPPLER = null;
    this.COLUMN_L1CA_CNO = null;
    this.COLUMN_L1PY_RANGE = null;
    this.COLUMN_L1PY_PHASE = null;
    this.COLUMN_L1PY_DOPPLER = null;
    this.COLUMN_L1PY_CNO = null;
    this.COLUMN_L2CA_RANGE = null;
    this.COLUMN_L2CA_PHASE = null;
    this.COLUMN_L2CA_DOPPLER = null;
    this.COLUMN_L2CA_CNO = null;
    this.COLUMN_L2PY_RANGE = null;
    this.COLUMN_L2PY_PHASE = null;
    this.COLUMN_L2PY_DOPPLER = null;
    this.COLUMN_L2PY_CNO = null;
}

function ValidateGPSData() {
    this.VALID = null;
    this.PRN = null;
    this.TYPE = null;
    this.COLUMN_RangeL1CA = null;
    this.COLUMN_PhaseL1CA = null;
    this.COLUMN_CNOL1CA = null;
    this.COLUMN_DopplerL1CA = null

    this.COLUMN_RangeL1PY = null;
    this.COLUMN_PhaseL1PY = null;
    this.COLUMN_CNOL1PY = null;
    this.COLUMN_DopplerL1PY = null

    this.COLUMN_RangeL2CA = null;
    this.COLUMN_PhaseL2CA = null;
    this.COLUMN_CNOL2CA = null;
    this.COLUMN_DopplerL2CA = null

    this.COLUMN_RangeL2PY = null;
    this.COLUMN_PhaseL2PY = null;
    this.COLUMN_CNOL2PY = null;
    this.COLUMN_DopplerL2PY = null


    this.COLUMN_L1CA_IS_VALID = null;
    this.COLUMN_L1CA_CPHQUALITY = null;
    this.COLUMN_L1CA_HALFCYCLEADJ = null;
    this.COLUMN_L1CA_PHASE_IS_VALID = null;
    this.COLUMN_L1CA_DOPPLER_IS_VALID = null;
    this.COLUMN_L1CA_CNO_IS_VALID = null;

    this.COLUMN_L2CA_IS_VALID = null;
    this.COLUMN_L2CA_CPHQUALITY = null;
    this.COLUMN_L2CA_HALFCYCLEADJ = null;
    this.COLUMN_L2CA_PHASE_IS_VALID = null;
    this.COLUMN_L2CA_DOPPLER_IS_VALID = null;
    this.COLUMN_L2CA_CNO_IS_VALID = null;

    this.COLUMN_L1PY_IS_VALID = null;
    this.COLUMN_L1PY_CPHQUALITY = null;
    this.COLUMN_L1PY_HALFCYCLEADJ = null;
    this.COLUMN_L1PY_PHASE_IS_VALID = null;
    this.COLUMN_L1PY_DOPPLER_IS_VALID = null;
    this.COLUMN_L1PY_CNO_IS_VALID = null;

    this.COLUMN_L2PY_IS_VALID = null;
    this.COLUMN_L2PY_CPHQUALITY = null;
    this.COLUMN_L2PY_HALFCYCLEADJ = null;
    this.COLUMN_L2PY_PHASE_IS_VALID = null;
    this.COLUMN_L2PY_DOPPLER_IS_VALID = null;
    this.COLUMN_L2PY_CNO_IS_VALID = null;

}

/*
function SBASDataStore()
{
   this.PRN                         = null;
   this.COLUMN_CA                   = null;
   this.COLUMN_L1CA                 = null;
   this.COLUMN_P1CA                 = null;
   this.COLUMN_P2CA                 = null;
   this.COLUMN_L2CA                 = null;
   this.COLUMN_L2CCA                = null;
   this.COLUMN_L2CCCA               = null;
   this.COLUMN_CACNO                = null;
   this.COLUMN_P2CNO                = null;
   this.COLUMN_L1CADOPPLER          = null;
   this.COLUMN_L2PDOPPLER           = null;
   this.COLUMN_L5QCA                = null;
   this.COLUMN_L5CA                 = null;
   this.COLUMN_L5QCNO               = null;
   this.COLUMN_L5DOPPLER            = null;
}

function ValidateSBASData()
{   
   this.VALID                       = null;
   this.PRN                         = null;
   this.TYPE                        = null;
   this.COLUMN_CA                   = null;
   this.COLUMN_L1CA                 = null;
   this.COLUMN_P1CA                 = null;
   this.COLUMN_L5QCA                = null;
   this.COLUMN_P2CA                 = null;
   this.COLUMN_L2CA                 = null;
   this.COLUMN_L2CCA                = null;
   this.COLUMN_L2CCCA               = null;
   this.COLUMN_CACNO                = null;
   this.COLUMN_P2CNO                = null;
   this.COLUMN_L1CADOPPLER          = null;
   this.COLUMN_L2PDOPPLER           = null;
   this.COLUMN_L5CA                 = null;
   this.COLUMN_L5QCNO               = null;
   this.COLUMN_L5DOPPLER            = null;
   this.COLUMN_CA_IS_VALID          = null;
   this.COLUMN_L1CA_IS_VALID        = null;
   this.COLUMN_P1CA_IS_VALID        = null;
   this.COLUMN_L5QCA_IS_VALID       = null;
   this.COLUMN_P2CA_IS_VALID        = null;
   this.COLUMN_L2CA_IS_VALID        = null;
   this.COLUMN_L2CA_CPHQUALITY      = null;
   this.COLUMN_L2CCA_IS_VALID       = null;
   this.COLUMN_L2CCCA_IS_VALID      = null;
   this.COLUMN_CACNO_IS_VALID       = null;
   this.COLUMN_P2CNO_IS_VALID       = null;
   this.COLUMN_L1CADOPPLER_IS_VALID = null;
   this.COLUMN_L2PDOPPLER_IS_VALID  = null;
   this.COLUMN_L5CA_IS_VALID        = null;
   this.COLUMN_L5QCNO_IS_VALID      = null;
   this.COLUMN_L5DOPPLER_IS_VALID   = null;
}
*/
function GLNDataStore()
{
   this.PRN                         = null;
   this.GLO_COLUMN_G1C              = null;
   this.GLO_COLUMN_L1C_GLO          = null;
   this.GLO_COLUMN_L1P_GLO          = null;
   this.GLO_COLUMN_P1_GLO           = null;
   this.GLO_COLUMN_P2_GLO           = null;
   this.GLO_COLUMN_G2C              = null;
   this.GLO_COLUMN_L2_GLO           = null;
   this.GLO_COLUMN_L2P_GLO          = null;
   this.GLO_COLUMN_G1CCNO           = null;
   this.GLO_COLUMN_G2CCNO           = null;
   this.GLO_COLUMN_G1DOPPLER        = null;
   this.GLO_COLUMN_G2DOPPLER        = null;
   this.GLO_COLUMN_P1DOPPLER        = null;
   this.GLO_COLUMN_P2DOPPLER        = null;
}

function ValidateGlnData()
{   
   this.VALID                       = null;
   this.PRN                         = null;
   this.TYPE                        = null;
   this.COLUMN_G1C                  = null;
   this.COLUMN_L1C_GLO              = null;
   this.COLUMN_L1P_GLO              = null;
   this.COLUMN_G1CCNO               = null;
   this.COLUMN_G1DOPPLER            = null;
   this.COLUMN_G2C                  = null;
   this.COLUMN_L2_GLO               = null;
   this.COLUMN_L2P_GLO              = null;
   this.COLUMN_G2CCNO               = null;
   this.COLUMN_G2DOPPLER            = null;
   this.COLUMN_P1_GLO               = null;
   this.COLUMN_P2_GLO               = null;
   this.COLUMN_P1DOPPLER            = null;
   this.COLUMN_P2DOPPLER            = null;
   this.COLUMN_G1C_IS_VALID         = null;
   this.COLUMN_L1C_GLO_IS_VALID     = null;
   this.COLUMN_L1C_GLO_CPHQUALITY   = null;
   this.COLUMN_L1C_GLO_HALFCYCLEADJ = null;
   this.COLUMN_L2P_GLO_IS_VALID     = null;
   this.COLUMN_L1P_GLO_IS_VALID     = null;
   this.COLUMN_G1CCNO_IS_VALID      = null;
   this.COLUMN_G1DOPPLER_IS_VALID   = null;
   this.COLUMN_G2C_IS_VALID         = null;
   this.COLUMN_L2_GLO_IS_VALID      = null;
   this.COLUMN_L2_GLO_CPHQUALITY    = null;
   this.COLUMN_G2CCNO_IS_VALID      = null;
   this.COLUMN_G2DOPPLER_IS_VALID   = null;
   this.COLUMN_P1_GLO_IS_VALID      = null;
   this.COLUMN_P2_GLO_IS_VALID      = null;
   this.COLUMN_P1DOPPLER_IS_VALID   = null;
   this.COLUMN_P2DOPPLER_IS_VALID   = null;
}
/*
function GALILEODataStore()
{
   this.PRN                         = null;
   this.COLUMN_CA                   = null;
   this.COLUMN_L1CA                 = null;
   this.COLUMN_P1CA                 = null;
   this.COLUMN_P2CA                 = null;
   this.COLUMN_L2CA                 = null;
   this.COLUMN_L2CCA                = null;
   this.COLUMN_L2CCCA               = null;
   this.COLUMN_CACNO                = null;
   this.COLUMN_P2CNO                = null;
   this.COLUMN_L1CADOPPLER          = null;
   this.COLUMN_L2PDOPPLER           = null;
   this.COLUMN_L5QCA                = null;
   this.COLUMN_L5CA                 = null;
   this.COLUMN_L5QCNO               = null;
   this.COLUMN_L5DOPPLER            = null;
}

function ValidateGALILEOData()
{   
   this.VALID                       = null;
   this.PRN                         = null;
   this.TYPE                        = null;
   this.COLUMN_CA                   = null;
   this.COLUMN_L1CA                 = null;
   this.COLUMN_P1CA                 = null;
   this.COLUMN_L5QCA                = null;
   this.COLUMN_P2CA                 = null;
   this.COLUMN_L2CA                 = null;
   this.COLUMN_L2CCA                = null;
   this.COLUMN_L2CCCA               = null;
   this.COLUMN_CACNO                = null;
   this.COLUMN_P2CNO                = null;
   this.COLUMN_L1CADOPPLER          = null;
   this.COLUMN_L2PDOPPLER           = null;
   this.COLUMN_L5CA                 = null;
   this.COLUMN_L5QCNO               = null;
   this.COLUMN_L5DOPPLER            = null;
   this.COLUMN_CA_IS_VALID          = null;
   this.COLUMN_L1CA_IS_VALID        = null;
   this.COLUMN_P1CA_IS_VALID        = null;
   this.COLUMN_L5QCA_IS_VALID       = null;
   this.COLUMN_P2CA_IS_VALID        = null;
   this.COLUMN_L2CA_IS_VALID        = null;
   this.COLUMN_L2CCA_IS_VALID       = null;
   this.COLUMN_L2CCCA_IS_VALID      = null;
   this.COLUMN_CACNO_IS_VALID       = null;
   this.COLUMN_P2CNO_IS_VALID       = null;
   this.COLUMN_L1CADOPPLER_IS_VALID = null;
   this.COLUMN_L2PDOPPLER_IS_VALID  = null;
   this.COLUMN_L5CA_IS_VALID        = null;
   this.COLUMN_L5QCNO_IS_VALID      = null;
   this.COLUMN_L5DOPPLER_IS_VALID   = null;
}

function BEIDOUDataStore()
{
   this.PRN                         = null;
   this.COLUMN_CA                   = null;
   this.COLUMN_L1CA                 = null;
   this.COLUMN_P1CA                 = null;
   this.COLUMN_P2CA                 = null;
   this.COLUMN_L2CA                 = null;
   this.COLUMN_L2CCA                = null;
   this.COLUMN_L2CCCA               = null;
   this.COLUMN_CACNO                = null;
   this.COLUMN_P2CNO                = null;
   this.COLUMN_L1CADOPPLER          = null;
   this.COLUMN_L2PDOPPLER           = null;
   this.COLUMN_L5QCA                = null;
   this.COLUMN_L5CA                 = null;
   this.COLUMN_L5QCNO               = null;
   this.COLUMN_L5DOPPLER            = null;
}

function ValidateBEIDOUData()
{   
   this.VALID                       = null;
   this.PRN                         = null;
   this.TYPE                        = null;
   this.COLUMN_CA                   = null;
   this.COLUMN_L1CA                 = null;
   this.COLUMN_P1CA                 = null;
   this.COLUMN_L5QCA                = null;
   this.COLUMN_P2CA                 = null;
   this.COLUMN_L2CA                 = null;
   this.COLUMN_L2CCA                = null;
   this.COLUMN_L2CCCA               = null;
   this.COLUMN_CACNO                = null;
   this.COLUMN_P2CNO                = null;
   this.COLUMN_L1CADOPPLER          = null;
   this.COLUMN_L2PDOPPLER           = null;
   this.COLUMN_L5CA                 = null;
   this.COLUMN_L5QCNO               = null;
   this.COLUMN_L5DOPPLER            = null;
   this.COLUMN_CA_IS_VALID          = null;
   this.COLUMN_L1CA_IS_VALID        = null;
   this.COLUMN_P1CA_IS_VALID        = null;
   this.COLUMN_L5QCA_IS_VALID       = null;
   this.COLUMN_P2CA_IS_VALID        = null;
   this.COLUMN_L2CA_IS_VALID        = null;
   this.COLUMN_L2CCA_IS_VALID       = null;
   this.COLUMN_L2CCCA_IS_VALID      = null;
   this.COLUMN_CACNO_IS_VALID       = null;
   this.COLUMN_P2CNO_IS_VALID       = null;
   this.COLUMN_L1CADOPPLER_IS_VALID = null;
   this.COLUMN_L2PDOPPLER_IS_VALID  = null;
   this.COLUMN_L5CA_IS_VALID        = null;
   this.COLUMN_L5QCNO_IS_VALID      = null;
   this.COLUMN_L5DOPPLER_IS_VALID   = null;
}
*/
var SPEED_OF_LIGHT                  = 299792458.0;
var L1_CARRIER_FREQUENCY            = 1575420000.0;
var L2_CARRIER_FREQUENCY            = 1227600000.0;
var L5_CARRIER_FREQUENCY            = 1176450000.0;
var L1_LAMBDA                       = (SPEED_OF_LIGHT/L1_CARRIER_FREQUENCY);
var L2_LAMBDA                       = (SPEED_OF_LIGHT/L2_CARRIER_FREQUENCY);
var L5_LAMBDA                       = (SPEED_OF_LIGHT/L5_CARRIER_FREQUENCY);
 
var COUNT_OF_GPS_ELEMENTS           = 32;
//var COUNT_OF_WAAS_ELEMENTS          = 19;
var COUNT_OF_GLONASS_ELEMENTS       = 24;
//var COUNT_OF_GALILEO_ELEMENTS       = 36;
//var COUNT_OF_BEIDOU_ELEMENTS        = 30;

var FREQTYPE =
{
   L1_FREQ :0,
   L2_FREQ :1,
   L5_FREQ :2
};
var MEASTYPE =
{
   INVD_MEAS_TYPE : -1,
   L1_CA          : 0, // CA on L1
   L1_P           : 1,  // P on L1
   L2_P           : 2,  // P on L2
   L2_C           : 3,  // C on L2 (do we need differnet types for L2CM and L2CL?)
   L5_Q           : 4,  // L5 Q
   L5_I           : 5,  // L5 I
   L1_GLO         : 6, // G1C
   L2_GLO         : 7,
   P1_GLO         : 8, //G1P
   P2_GLO         : 9, //G2P
   L1_E1B         : 10
};

GLONASS_WAVELENGTHS = [
    // G1               PRN FreId
    [
    0.18713636579276   //1:(00)
   ,0.18739956743241   //2:(01) =>(-4)
   ,0.18680840160455   //3:(05)
   ,0.18713636579276   //4:(06) =>(00)
   ,0.18713636579276   //5:(00)
   ,0.18739956743241   //6:(01) =>(-4)
   ,0.18680840160455   //7:(05)
   ,0.18674294666355   //8:(06)
   ,0.18726787413133   //9:(-2)
   ,0.18759745504322   //10:(04) =>(-7)
   ,0.18713636579276   //11:(00)
   ,0.18713636579276   //12:(00)
   ,0.18726787413133   //13:(-2)
   ,0.18759745504322   //14:(04) =>(-7)
   ,0.18713636579276   //15:(00)
   ,0.18713636579276   //16:(00)
   ,0.18687390244663	  //17:(-1) =>(04)
   ,0.18733369763718	  //18:(-3)
   ,0.18693944923808	  //19:(03)
   ,0.18700504202729	  //20:(02)
   ,0.18687390244663	  //21:(-1) =>(04)
   ,0.18733369763718	  //22:(-3)
   ,0.18693944923808	  //23:(03)
   ,0.18700504202729	  //24:(02)
   ]
   // G2
   ,[
    0.24060389887640   //1:(00)
   ,0.24094230098453   //2:(01) =>(-4)
   ,0.24018223063442   //3:(05) 
   ,0.24060389887640   //4:(06) =>(00)
   ,0.24060389887640   //5:(00) 
   ,0.24094230098453   //6:(01) =>(-4)
   ,0.24018223063442   //7:(05)
   ,0.24009807428171   //8:(06)
   ,0.24077298102600   //9:(-2)
   ,0.24119672791271   //10:(04) =>(-7)
   ,0.24060389887640   //11:(00)
   ,0.24060389887640   //12:(00)
   ,0.24077298102600   //13:(-2)
   ,0.24119672791271   //14:(04) =>(-7)
   ,0.24060389887640   //15:(00)
   ,0.24060389887640   //16:(00)
   ,0.24026644600281	  //17:(-1) =>(04)
   ,0.24085761124780	  //18:(-3)
   ,0.24035072044897	  //19:(03)
   ,0.24043505403509	  //20:(02)
   ,0.24026644600281	  //21:(-1) =>(04)
   ,0.24085761124780	  //22:(-3)
   ,0.24035072044897	  //23:(03)
   ,0.24043505403509	  //24:(02)
   ]
    // Narrow Lane
   ,[
    0.10526420575843   //1:(00)
   ,0.10541225668073   //2:(01) =>(-4)
   ,0.10507972590256   //3:(05) 
   ,0.10526420575843   //4:(06) =>(00)
   ,0.10526420575843   //5:(00) 
   ,0.10541225668073   //6:(01) =>(-4)
   ,0.10507972590256   //7:(05)
   ,0.10504290749825   //8:(06)
   ,0.10533817919888   //9:(-2)
   ,0.10552356846181   //10:(04)  =>(-7)
   ,0.10526420575843   //11:(00)
   ,0.10526420575843   //12:(00)
   ,0.10533817919888   //13:(-2)
   ,0.10552356846181   //14:(04)  =>(-7)
   ,0.10526420575843   //15:(00)
   ,0.10526420575843   //16:(00)
   ,0.10511657012623	  //17:(-1)  =>(04)
   ,0.10537520492091	  //18:(-3)
   ,0.10515344019642	  //19:(03)
   ,0.10519033614035	  //20:(02)
   ,0.10511657012623	  //21:(-1) =>(04)
   ,0.10537520492091	  //22:(-3)
   ,0.10515344019642	  //23:(03)
   ,0.10519033614035	  //24:(02)
   ]
];

function ISGPS(id)       { return (id >= 1) && (id <= 37); }
function ISGLONASS(id)   { return (id >= 38) && (id <= 61); }
//function ISGALILEO(id)   { return (id >= 62) && (id <= 97); }
//function ISSBAS(id)      { return (id >= 120) && (id <= 138); }
//function ISBEIDOU(id)    { return (id >= 139) && (id <= 168); }

function meas1b_obj()
{
   var MsgName = "[MEAS1B]"

   this.update = function (input) 
   {
       var start = input.indexOf(MsgName);

       //don't start parsing if this is not the right message
       if (start < 0) 
       {
           return false;
       }
       this.name = MsgName;

       //init the parser
       var p = new parser(input, start + MsgName.length);

       //get the meas1b general info
       this.length = p.fetchU16();
       this.week = p.fetchU16();
       this.TOWms = p.fetchU32();
       this.TOW = this.TOWms / 1000;
       this.ver = p.fetchU04();
       this.conf = p.fetchU04();

       this.numSv = p.fetchU08();


       //initialize variables
       measNum = 0;
       chnlNum = 0;
       if (this.gpsDataStore == null) 
       {
           this.gpsDataStore = new Array(COUNT_OF_GPS_ELEMENTS);
       }
       if (this.validateGPSData == null) 
       {
           this.validateGPSData = new Array(COUNT_OF_GPS_ELEMENTS);
       }
       /* 
       if(this.sbasDataStore == null) 
       {
       this.sbasDataStore = new Array(COUNT_OF_WAAS_ELEMENTS);
       }
       if(this.validateSBASData == null) 
       {
       this.validateSBASData = new Array(COUNT_OF_WAAS_ELEMENTS);
       } 
       */
       if (this.glnDataStore == null) 
       {
           this.glnDataStore = new Array(COUNT_OF_GLONASS_ELEMENTS);
       }
       if (this.validateGlnData == null) 
       {
           this.validateGlnData = new Array(COUNT_OF_GLONASS_ELEMENTS);
       }
       /* 
       if(this.galileoDataStore == null) 
       {
       this.galileoDataStore = new Array(COUNT_OF_GALILEO_ELEMENTS);
       }
       if(this.validateGalileoData == null) 
       {
       this.validateGalileoData = new Array(COUNT_OF_GALILEO_ELEMENTS);
       }
       if(this.beidouDataStore == null) 
       {
       this.beidouDataStore = new Array(COUNT_OF_BEIDOU_ELEMENTS);
       }
       if(this.validateBeidouData == null) 
       {
       this.validateBeidouData = new Array(COUNT_OF_BEIDOU_ELEMENTS);
       } 
       */
       if (this.m_nPseudorangeGps == null)
       {
           this.m_nPseudorangeGps = new Array(COUNT_OF_GPS_ELEMENTS);
       }
       /* 
       if(this.m_nPseudorangeSbas == null) 
       {
       this.m_nPseudorangeSbas = new Array(COUNT_OF_WAAS_ELEMENTS);
       } 
       */
       if (this.m_nPseudorangeGlo == null) 
       {
           this.m_nPseudorangeGlo = new Array(COUNT_OF_GLONASS_ELEMENTS);
       }
       /*if(this.m_nPseudorangeGalileo == null) 
       {
       this.m_nPseudorangeGalileo = new Array(COUNT_OF_GALILEO_ELEMENTS);
       }
       if(this.m_nPseudorangeBeidou == null) 
       {
       this.m_nPseudorangeBeidou = new Array(COUNT_OF_BEIDOU_ELEMENTS);
       }*/

       if (this.signal == null) 
       {
           this.signal = new Array(100);
       }

       //********** begin parsing each byte of meas1b function ************//
       //iterate through all the available Satellites in the message
       for (i = 0; i < this.numSv; i++) 
       {
           svId = p.fetchU08();
           u32 = p.fetchU32();
           dwNumCode = ((u32 & 0xF0000000) >> 28);     //4 bits
           fCoarseRange = (u32 & 0xFFFFE00) >> 9;  //19 bits
           fCoarseRange *= 100.;
           fCoarseDoppler = (u32 & 0x1FF);        //9 bits
           if (fCoarseDoppler > 0xFF) 
	   {
               fCoarseDoppler -= 0x200;
           }

           fCoarseDoppler *= 10.;

           if (ISGPS(svId)) 
	   {
               prn = svId;
               dwSatConst = "GPS";
           }
           else if (ISGLONASS(svId)) 
	   {
               prn = svId - 37;
               dwSatConst = "GLONASS";
           }
           /* 
           else if (ISGALILEO(svId)) 
           {
           prn = svId - 62; 
           dwSatConst = "GALILEO";
           }
           else if (ISBEIDOU(svId)) 
           {
           prn = svId - 139;
           dwSatConst = "BEIDOU";
           }
           else if (ISSBAS(svId)) 
           {
           prn = svId; //not shift
           dwSatConst = "SBAS";
           }
           */
           else
               continue;

           for (j = 0; j < dwNumCode; j++) 
	   {
               u16 = p.fetchU16();

               if (this.ver == 1) 
	       {
                   // revision 1:
                   // U16 
                   // U03 Frequency Number
                   // U03 Code Type
                   // U06 CN0
                   // U04 Cycle Slip Count
                   freqType = ((u16 & 0xE000) >>> 13);    //3 bits frequency number
                   codeType = ((u16 & 0x1C00) >>> 10);   // 3 bits code type
                   cphQual = 0;
                   halfCycleAdj = 0;
               }
               else if (this.ver >= 2) 
	       {
                   // revision 2:
                   // U16 
                   // U01 Half-Cycle Adjusted
                   // U02 Frequency Number
                   // U01 CPH Quality
                   // U02 Code Type
                   // U06 CN0
                   // U04 Cycle Slip Count
                   halfCycleAdj = ((u16 & 0x8000) >>> 15);
                   freqType = ((u16 & 0x6000) >>> 13);
                   cphQual = ((u16 & 0x1000) >>> 12);
                   codeType = ((u16 & 0x0C00) >>> 10);
               }

               cno = ((u16 & 0x3F0) >>> 4);    // 6 bits cno
               cycleSlip = (u16 & 0xF);           //cycle clip count
               u16 = p.fetchU16();             //delta range
               if (u16 != 0x8000) 
	       {
                   prValid = 1;
                   if (u16 > 0x8000) 
		   {
                       delta_range = u16 - 0x10000;
                   }
                   else 
		   {
                       delta_range = u16;
                   }
               }
               else 
	       {
                   prValid = 0;
               }

               u32 = p.fetchU32();
               u32Tmp = (u32 & 0xFFFFF000) >>> 12;  //delta phase
               if (u32Tmp != 0x80000) 
	       {
                   cpValid = 1;
                   if (u32Tmp > 0x80000) 
		   {
                       delta_phase = u32Tmp - 0x100000;
                   }
                   else 
		   {
                       delta_phase = u32Tmp;
                   }
               }
               else 
	       {
                   cpValid = 0;
               }
               u32Tmp = (u32 & 0xFFF);              //delta doppler
               if (u32Tmp != 0x800) 
	       {
                   dpValid = 1;
                   if (u32Tmp > 0x800) 
		   {
                       delta_doppler = u32Tmp - 0x1000;
                   }
                   else 
		   {
                       delta_doppler = u32Tmp;
                   }
               }
               else 
	       {
                   dpValid = 0;
               }

               measType = 0xFF;         //init with a non-meas type
               if (dwSatConst == "GPS") 
	       {
                   switch (freqType) 
		   {
                       case FREQTYPE.L1_FREQ:
                           fWaveLength = L1_LAMBDA;
                           switch (codeType) 
			   {
                               case 0: measType = MEASTYPE.L1_CA; break;
                               case 1: measType = MEASTYPE.L1_P; break;
                           }
                           break;
                       case FREQTYPE.L2_FREQ:
                           fWaveLength = L2_LAMBDA;
                           switch (codeType) 
			   {
                               case 0: measType = MEASTYPE.L2_C; chnlNum++; break;
                               case 1: measType = MEASTYPE.L2_P; chnlNum++; break;
                           }
                           break;
                       case FREQTYPE.L5_FREQ:
                           fWaveLength = L5_LAMBDA;
                           switch (codeType) 
			   {
                               case 0: measType = MEASTYPE.L5_Q; chnlNum++; break;
                               case 1: measType = MEASTYPE.L5_I; chnlNum++; break;
                           }
                           break;
                   }
               } //end if GPS
               else if (dwSatConst == "GLONASS") 
	       {
                   switch (freqType) 
		   {
                       case FREQTYPE.L1_FREQ:
                           fWaveLength = GLONASS_WAVELENGTHS[FREQTYPE.L1_FREQ][prn - 1];
                           switch (codeType) 
			   {
                               case 0: measType = MEASTYPE.L1_GLO; break;   //g1c
                               case 1: measType = MEASTYPE.P1_GLO; break;    //g1p
                           }
                           break;
                       case FREQTYPE.L2_FREQ:
                           fWaveLength = GLONASS_WAVELENGTHS[FREQTYPE.L2_FREQ][prn - 1];
                           switch (codeType) 
			   {
                               case 0: measType = MEASTYPE.L2_GLO; chnlNum++; break; //g2c
                               case 1: measType = MEASTYPE.P2_GLO; chnlNum++; break;     //g2p
                           }
                           break;
                   }
               } //end if GLONASS
               /* 
               else if (dwSatConst == "SBAS")   //not support L5 yet
               {
               switch (freqType) 
               {
               case FREQTYPE.L1_FREQ:
               fWaveLength = L1_LAMBDA;
               switch (codeType) 
               {
               case 0: measType = MEASTYPE.L1_CA; break;
               }
               break;
               }
               } //end if SBAS
               else if (dwSatConst == "GALILEO") 
               {
               switch (freqType) 
               {
               case FREQTYPE.L1_FREQ:
               fWaveLength = L1_LAMBDA;
               switch (codeType) 
               {
               case 0: measType = MEASTYPE.L1_CA; break;
               case 1: measType = MEASTYPE.L1_P; break;
               }
               break;
               case FREQTYPE.L2_FREQ:
               fWaveLength = L2_LAMBDA;
               switch (codeType) 
               {
               case 0: measType = MEASTYPE.L2_C; chnlNum++; break;
               case 1: measType = MEASTYPE.L2_P; chnlNum++; break;
               }
               break;
               case FREQTYPE.L5_FREQ:
               fWaveLength = L5_LAMBDA;
               switch (codeType) 
               {
               case 0: measType = MEASTYPE.L5_Q; chnlNum++; break;
               case 1: measType = MEASTYPE.L5_I; chnlNum++; break;
               }
               break;
               }
               } //end if GALILEO
               else if (dwSatConst == "BEIDOU") 
               {
               switch (freqType) 
               {
               case FREQTYPE.L1_FREQ:
               fWaveLength = L1_LAMBDA;
               switch (codeType) 
               {
               case 0: measType = MEASTYPE.L1_CA; break;
               case 1: measType = MEASTYPE.L1_P; break;
               }
               break;
               case FREQTYPE.L2_FREQ:
               fWaveLength = L2_LAMBDA;
               switch (codeType) 
               {
               case 0: measType = MEASTYPE.L2_C; chnlNum++; break;
               case 1: measType = MEASTYPE.L2_P; chnlNum++; break;
               }
               break;
               case FREQTYPE.L5_FREQ:
               fWaveLength = L5_LAMBDA;
               switch (codeType) 
               {
               case 0: measType = MEASTYPE.L5_Q; chnlNum++; break;
               case 1: measType = MEASTYPE.L5_I; chnlNum++; break;
               }
               break;
               }
               } //end if BEIDOU
               */
               //if non meas type match, continue
               if (measType == 0xFF) 
	       {
                   continue;
               }
               //recover the ranges,phases and dopplers
               if (prValid) 
	       {
                   recovered_range = fCoarseRange + delta_range * 0.01;
                   if (cpValid) 
		   {
                       recovered_phase = delta_phase / 256.0 + recovered_range / fWaveLength; //cycles
                   }
                   else 
		   {
                       recovered_phase = 0;
                   }
               }
               else 
	       {
                   recovered_range = 0;
               }
               if (dpValid) 
	       {
                   recovered_doppler = (delta_doppler * 0.005 + fCoarseDoppler) / fWaveLength;   //change the unit to be cycles/s
               }
               else 
	       {
                   recovered_doppler = 0;
               }

               if (this.signal[measNum] == null) 
	       {
                   this.signal[measNum] = new Signal();
               }

               this.signal[measNum].valid = prValid;
               this.signal[measNum].cpValid = cpValid;
               this.signal[measNum].dpValid = dpValid;
               this.signal[measNum].channel = chnlNum;     //do not have this field any more, fill the measurement number here
               this.signal[measNum].prn = prn;
               this.signal[measNum].measType = measType;
               // needed for revision 2 and MEAS3B
               this.signal[measNum].halfCycleAdj = halfCycleAdj;
               this.signal[measNum].cphQuality = cphQual;
               this.signal[measNum].cno = cno;
               this.signal[measNum].cycleSlipCount = cycleSlip;
               this.signal[measNum].pseudorange = recovered_range;
               this.signal[measNum].carrierPhase = recovered_phase;
               this.signal[measNum].doppler = recovered_doppler;
               this.signal[measNum].constType = dwSatConst;

               measNum++;
           }
           chnlNum++;
       }
       this.measNum = measNum;
       this.organizeData();

       return true;
   }

   this.organizeData = function () 
   {//********** begin to organize the GPS data into columns ************//

       // mark all possible values as invalid
       if (this.validateGPSData != null) 
       {
           for (idx = 0; idx < COUNT_OF_GPS_ELEMENTS; idx++) 
	   {
               if (this.validateGPSData[idx] != null) 
	       {
                   this.validateGPSData[idx].VALID = false;
                   this.validateGPSData[idx].PRN = 0;
                   this.validateGPSData[idx].TYPE = -1;

                   this.validateGPSData[idx].COLUMN_L1CA_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L1CA_CPHQUALITY = false;
                   this.validateGPSData[idx].COLUMN_L1CA_HALFCYCLEADJ = false;
                   this.validateGPSData[idx].COLUMN_L1CA_PHASE_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L1CA_DOPPLER_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L1CA_CACNO_IS_VALID = false;

                   this.validateGPSData[idx].COLUMN_L2CA_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L2CA_CPHQUALITY = false;
                   this.validateGPSData[idx].COLUMN_L2CA_HALFCYCLEADJ = false;
                   this.validateGPSData[idx].COLUMN_L2CA_PHASE_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L2CA_DOPPLER_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L2CA_CACNO_IS_VALID = false;

                   this.validateGPSData[idx].COLUMN_L1PY_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L1PY_CPHQUALITY = false;
                   this.validateGPSData[idx].COLUMN_L1PY_HALFCYCLEADJ = false;
                   this.validateGPSData[idx].COLUMN_L1PY_PHASE_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L1PY_DOPPLER_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L1PY_CACNO_IS_VALID = false;

                   this.validateGPSData[idx].COLUMN_L2PY_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L2PY_CPHQUALITY = false;
                   this.validateGPSData[idx].COLUMN_L2PY_HALFCYCLEADJ = false;
                   this.validateGPSData[idx].COLUMN_L2PY_PHASE_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L2PY_DOPPLER_IS_VALID = false;
                   this.validateGPSData[idx].COLUMN_L2PY_CACNO_IS_VALID = false;
               }
	    //Reset pseudorange
            if(( this.m_nPseudorangeGps != null ) && ( this.m_nPseudorangeGps[idx] != null )) 
            {
               this.m_nPseudorangeGps[idx] = 0; 
            }

           } //end of for


       }

       /*
       if( this.validateSBASData != null )
       {
       for ( idx = 0; idx < COUNT_OF_WAAS_ELEMENTS; idx++ )
       {
       if( this.validateSBASData[idx] != null ) 
       {
       this.validateSBASData[idx].VALID = false;
       this.validateSBASData[idx].PRN = 0;
       this.validateSBASData[idx].TYPE = "INVD_MEAS_TYPE";
       this.validateSBASData[idx].COLUMN_CA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L1CA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_P1CA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L5QCA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_P2CA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L2CA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L2CCA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L2CCCA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_CACNO_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_P2CNO_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L1CADOPPLER_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L2PDOPPLER_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L5CA_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L5QCNO_IS_VALID = false;
       this.validateSBASData[idx].COLUMN_L5DOPPLER_IS_VALID= false;
       }

       //Reset pseudorange
       if(( this.m_nPseudorangeSbas != null ) && ( this.m_nPseudorangeSbas[idx] != null )) 
       {
       this.m_nPseudorangeSbas[idx] = 0; 
       }
       }
       }

       if( this.validateGALILEOData != null )
       {
       for ( idx = 0; idx < COUNT_OF_GALILEO_ELEMENTS; idx++ )
       {
       if( this.validateGALILEOData[idx] != null ) 
       {
       this.validateGALILEOData[idx].VALID = false;
       this.validateGALILEOData[idx].PRN = 0;
       this.validateGALILEOData[idx].TYPE = "INVD_MEAS_TYPE";
       this.validateGALILEOData[idx].COLUMN_CA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L1CA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_P1CA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L5QCA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_P2CA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L2CA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L2CA_CPHQUALITY = false;
       this.validateGALILEOData[idx].COLUMN_L2CCA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L2CCCA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_CACNO_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_P2CNO_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L1CADOPPLER_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L2PDOPPLER_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L5CA_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L5QCNO_IS_VALID = false;
       this.validateGALILEOData[idx].COLUMN_L5DOPPLER_IS_VALID= false;
       }
       //Reset pseudorange
       if(( this.m_nPseudorangeGalileo != null ) && ( this.m_nPseudorangeGalileo[idx] != null )) 
       {
       this.m_nPseudorangeGalileo[idx] = 0; 
       }
       }
      
       }
       */
       if (this.validateGlnData != null) 
       {
           for (idx = 0; idx < COUNT_OF_GLONASS_ELEMENTS; idx++) 
	   {
               if (this.validateGlnData[idx] != null) 
	       {
                   this.validateGlnData[idx].VALID = false;
                   this.validateGlnData[idx].PRN = 0;
                   this.validateGlnData[idx].TYPE = "INVD_MEAS_TYPE";
                   this.validateGlnData[idx].COLUMN_G1C_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_L1C_GLO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_L1C_GLO_CPHQUALITY = false;
                   this.validateGlnData[idx].COLUMN_L1C_GLO_HALFCYCLEADJ = false;
                   this.validateGlnData[idx].COLUMN_L2P_GLO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_L1P_GLO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_G1CCNO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_G1DOPPLER_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_G2C_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_L2_GLO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_L2_GLO_CPHQUALITY = false;
                   this.validateGlnData[idx].COLUMN_G2CCNO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_G2DOPPLER_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_P1_GLO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_P2_GLO_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_P1DOPPLER_IS_VALID = false;
                   this.validateGlnData[idx].COLUMN_P2DOPPLER_IS_VALID = false;

               }
               //Reset pseudorange
               if ((this.m_nPseudorangeGlo != null) && (this.m_nPseudorangeGlo[idx] != null)) 
	       {
                   this.m_nPseudorangeGlo[idx] = 0;
               }
           }
       }
       /*
       if( this.validateBeidouData != null )
       {
       for ( idx = 0; idx < COUNT_OF_BEIDOU_ELEMENTS; idx++)
       {
       if( this.validateBeidouData[idx] != null ) 
       {
       this.validateBeidouData[idx].VALID = false;
       this.validateBeidouData[idx].PRN = 0;
       this.validateBeidouData[idx].TYPE = "INVD_MEAS_TYPE";
       this.validateBeidouData[idx].COLUMN_G1C_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_L1C_GLO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_L1C_GLO_CPHQUALITY = false;
       this.validateBeidouData[idx].COLUMN_L1C_GLO_HALFCYCLEADJ = false;
       this.validateBeidouData[idx].COLUMN_L2P_GLO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_L1P_GLO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_G1CCNO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_G1DOPPLER_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_G2C_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_L2_GLO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_L2_GLO_CPHQUALITY = false;
       this.validateBeidouData[idx].COLUMN_G2CCNO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_G2DOPPLER_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_P1_GLO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_P2_GLO_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_P1DOPPLER_IS_VALID = false;
       this.validateBeidouData[idx].COLUMN_P2DOPPLER_IS_VALID = false;

       }
       //Reset pseudorange
       if(( this.m_nPseudorangeBeidou != null ) && ( this.m_nPseudorangeBeidou[idx] != null )) 
       {
       this.m_nPseudorangeBeidou[idx] = 0; 
       }
       }
       }
       */

       //Pass 1: Collect Data
       for (signalCount = 0; signalCount < this.measNum; signalCount++) 
       {
           measType = this.signal[signalCount].measType;

           //***********************  SBAS/GPS/GALILEO/BEIDOU   *************************/
           if (measType == MEASTYPE.L1_CA || measType == MEASTYPE.L1_P ||
              measType == MEASTYPE.L2_P || measType == MEASTYPE.L2_C ||
              measType == MEASTYPE.L5_Q
              ) 
	      {
               prn = this.signal[signalCount].prn;
               /*
               if(this.signal[signalCount].constType == "SBAS") 
               {
               idx = prn - 120;

               if(this.validateSBASData[idx] == null) 
               {
               this.validateSBASData[idx] = new ValidateSBASData();
               }
                    
               this.validateSBASData[idx].VALID = true;
               this.validateSBASData[idx].PRN = prn;
               pseudorange    = this.signal[signalCount].pseudorange;
               carrier_phase  = this.signal[signalCount].carrierPhase;

               this.validateSBASData[idx].TYPE = measType;


               if ( measType == MEASTYPE.L1_CA) 
               {
               this.validateSBASData[idx].COLUMN_CA = pseudorange;
               this.validateSBASData[idx].COLUMN_CA_IS_VALID = true;
               if (this.signal[signalCount].cpValid )
               {
               this.validateSBASData[idx].COLUMN_L1CA = carrier_phase * L1_LAMBDA - pseudorange;
               this.validateSBASData[idx].COLUMN_L1CA_IS_VALID = true;
               }

               if ( this.signal[signalCount].valid ) 
               {
               this.m_nPseudorangeSbas[idx] = pseudorange;
               }

               this.validateSBASData[idx].COLUMN_CACNO = this.signal[signalCount].cno;
               this.validateSBASData[idx].COLUMN_L1CADOPPLER = this.signal[signalCount].doppler;
               this.validateSBASData[idx].COLUMN_CACNO_IS_VALID = true;
               this.validateSBASData[idx].COLUMN_L1CADOPPLER_IS_VALID = true;
               }
               else if ( measType == MEASTYPE.L1_P)
               {
               if ( this.m_nPseudorangeSbas[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateSBASData[idx].COLUMN_P1CA = 0.0;
               this.validateSBASData[idx].COLUMN_P1CA_IS_VALID = false;
               }
               else
               {
               this.validateSBASData[idx].COLUMN_P1CA = pseudorange - this.m_nPseudorangeSbas[idx];
               this.validateSBASData[idx].COLUMN_P1CA_IS_VALID = true;
               }
               }
               }
               else if ( measType == MEASTYPE.L2_P)
               {
               if ( this.m_nPseudorangeSbas[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateSBASData[idx].COLUMN_P2CA = 0.0;
               this.validateSBASData[idx].COLUMN_P2CA_IS_VALID = false;
               }
               else
               {
               this.validateSBASData[idx].COLUMN_P2CA = pseudorange - this.m_nPseudorangeSbas[idx];
               this.validateSBASData[idx].COLUMN_P2CA_IS_VALID = true;
               }
               if( this.signal[signalCount].cpValid )
               {
               this.validateSBASData[idx].COLUMN_L2CA = carrier_phase* L2_LAMBDA - this.m_nPseudorangeSbas[idx];
               this.validateSBASData[idx].COLUMN_L2CA_IS_VALID = true;
               }
               }
               this.validateSBASData[idx].COLUMN_P2CNO = this.signal[signalCount].cno;
               this.validateSBASData[idx].COLUMN_L2PDOPPLER = this.signal[signalCount].doppler;
               this.validateSBASData[idx].COLUMN_P2CNO_IS_VALID = true;
               this.validateSBASData[idx].COLUMN_L2PDOPPLER_IS_VALID = true;
               }
               else if ( measType == MEASTYPE.L2_C)
               {
               if ( this.m_nPseudorangeSbas[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateSBASData[idx].COLUMN_L2CCA = 0.0;
               this.validateSBASData[idx].COLUMN_L2CCA_IS_VALID = false;
               }
               else
               {
               this.validateSBASData[idx].COLUMN_L2CCA = pseudorange - this.m_nPseudorangeSbas[idx];
               this.validateSBASData[idx].COLUMN_L2CCA_IS_VALID = true;
               }
               if( this.signal[signalCount].cpValid )
               {
               this.validateSBASData[idx].COLUMN_L2CCCA = carrier_phase *L2_LAMBDA - this.m_nPseudorangeSbas[idx];
               this.validateSBASData[idx].COLUMN_L2CCCA_IS_VALID = true;
               }
               }
               }
               else if ( measType == MEASTYPE.L5_Q )
               {
               if ( this.m_nPseudorangeSbas[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateSBASData[idx].COLUMN_L5QCA = 0.0;
               this.validateSBASData[idx].COLUMN_L5QCA_IS_VALID = false;
               }
               else
               {
               this.validateSBASData[idx].COLUMN_L5QCA = pseudorange - this.m_nPseudorangeSbas[idx];
               this.validateSBASData[idx].COLUMN_L5QCA_IS_VALID = true;
               }

               if( this.signal[signalCount].cpValid )
               {
               this.validateSBASData[idx].COLUMN_L5CA = carrier_phase *L5_LAMBDA - this.m_nPseudorangeSbas[idx];
               this.validateSBASData[idx].COLUMN_L5CA_IS_VALID = true;
               }
               this.validateSBASData[idx].COLUMN_L5QCNO = this.signal[signalCount].cno;
               this.validateSBASData[idx].COLUMN_L5DOPPLER = this.signal[signalCount].doppler;
               this.validateSBASData[idx].COLUMN_L5QCNO_IS_VALID = true;
               this.validateSBASData[idx].COLUMN_L5DOPPLER_IS_VALID = true;
               }
               }
               }
               */
               if (this.signal[signalCount].constType == "GPS") 
	       {
                   idx = prn - 1;

                   if (this.validateGPSData[idx] == null) 
		   {
                       this.validateGPSData[idx] = new ValidateGPSData();
                   }

                   pseudorange = this.signal[signalCount].pseudorange;
                   carrier_phase = this.signal[signalCount].carrierPhase;
                   this.validateGPSData[idx].VALID = true;
                   this.validateGPSData[idx].PRN = prn;
                   this.validateGPSData[idx].TYPE = measType;


                   if (measType == MEASTYPE.L1_CA) 
		   {
                       this.validateGPSData[idx].COLUMN_RangeL1CA = pseudorange;
                       this.validateGPSData[idx].COLUMN_L1CA_IS_VALID = true;

                       if (this.signal[signalCount].cpValid) 
		       {
                           phase = carrier_phase * L1_LAMBDA - pseudorange;
                           this.validateGPSData[idx].COLUMN_PhaseL1CA = phase;
                           this.validateGPSData[idx].COLUMN_L1CA_PHASE_IS_VALID = true;

                           if (this.signal[signalCount].cphQuality != 0) 
			   {
                               this.validateGPSData[idx].COLUMN_L1CA_CPHQUALITY = true;
                           }
                           if (this.signal[signalCount].halfCycleAdj != 0) 
			   {
                               this.validateGPSData[idx].COLUMN_L1CA_HALFCYCLEADJ = true;
                           }
                       }

                       if (this.signal[signalCount].valid) 
		       {
                           this.m_nPseudorangeGps[idx] = pseudorange;
                       }


                       if (this.signal[signalCount].dpValid) 
		       {
                           this.validateGPSData[idx].COLUMN_DopplerL1CA = this.signal[signalCount].doppler;
                           this.validateGPSData[idx].COLUMN_L1CA_DOPPLER_IS_VALID = true;
                       }

                       this.validateGPSData[idx].COLUMN_CNOL1CA = this.signal[signalCount].cno;
                       this.validateGPSData[idx].COLUMN_L1CA_CNO_IS_VALID = true;
                   }
                   /******************************************L1P****************************************************/
                   else if (measType == MEASTYPE.L1_P) 
		   {
                       if (this.m_nPseudorangeGps[idx] > 0) 
		       {
                           if ((pseudorange > -1.0) && (pseudorange < 1.0)) 
			   {
                               this.validateGPSData[idx].COLUMN_RangeL1PY = 0.0;
                               this.validateGPSData[idx].COLUMN_L1PY_IS_VALID = false;
                           }
                           else 
			   {
                               range = pseudorange - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_RangeL1PY = pseudorange - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_L1PY_IS_VALID = true;
                           }

                           if (this.signal[signalCount].cpValid) 
			   {
                               phase = carrier_phase * L1_LAMBDA - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_PhaseL1PY = phase;
                               this.validateGPSData[idx].COLUMN_L1PY_PHASE_IS_VALID = true;
                           }
                       }
                       if (this.signal[signalCount].dpValid) 
		       {
                           this.validateGPSData[idx].COLUMN_DopplerL1PY = this.signal[signalCount].doppler;
                           this.validateGPSData[idx].COLUMN_L1PY_DOPPLER_IS_VALID = true;
                       }

                       this.validateGPSData[idx].COLUMN_CNOL1PY = this.signal[signalCount].cno;
                       this.validateGPSData[idx].COLUMN_L1PY_CNO_IS_VALID = true;
                   }



                   /******************************************L2P****************************************************/
                   else if (measType == MEASTYPE.L2_P) 
		   {
                       if (this.m_nPseudorangeGps[idx] > 0) 
		       {
                           if ((pseudorange > -1.0) && (pseudorange < 1.0)) 
			   {
                               this.validateGPSData[idx].COLUMN_RangeL2PY = 0.0;
                               this.validateGPSData[idx].COLUMN_L2PY_IS_VALID = false;
                           }
                           else 
			   {
                               this.validateGPSData[idx].COLUMN_RangeL2PY = pseudorange - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_L2PY_IS_VALID = true;
                           }
                           if (this.signal[signalCount].cpValid) 
                           {
                               this.validateGPSData[idx].COLUMN_PhaseL2PY = carrier_phase * L2_LAMBDA - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_L2PY_PHASE_IS_VALID = true;

                               if (this.signal[signalCount].cphQuality != 0) 
                               {
                                       this.validateGPSData[idx].COLUMN_L2PY_CPHQUALITY = true;
                               }
                           }
                       }

                       if (this.signal[signalCount].dpValid) 
                       {
                           this.validateGPSData[idx].COLUMN_DopplerL2PY = this.signal[signalCount].doppler;
                           this.validateGPSData[idx].COLUMN_L2PY_DOPPLER_IS_VALID = true;
                       }

                       this.validateGPSData[idx].COLUMN_CNOL2PY = this.signal[signalCount].cno;
                       this.validateGPSData[idx].COLUMN_L2PY_CNO_IS_VALID = true;
                   }

                   /*****************************************************L2C****************************************************/
                   else if (measType == MEASTYPE.L2_C) 
		   {
                       if (this.m_nPseudorangeGps[idx] > 0) 
		       {
                           if ((pseudorange > -1.0) && (pseudorange < 1.0)) 
			   {
                               this.validateGPSData[idx].COLUMN_RangeL2CA = 0.0;
                               this.validateGPSData[idx].COLUMN_L2CA_IS_VALID = false;
                           }
                           else {
                               this.validateGPSData[idx].COLUMN_RangeL2CA = pseudorange - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_L2CA_IS_VALID = true;
                           }
                           if (this.signal[signalCount].cpValid) 
			   {
                               this.validateGPSData[idx].COLUMN_PhaseL2CA = carrier_phase * L2_LAMBDA - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_L2CA_PHASE_IS_VALID = true;
                           }

                       }
                       if (this.signal[signalCount].dpValid) 
		       {
                           this.validateGPSData[idx].COLUMN_DopplerL2CA = this.signal[signalCount].doppler;
                           this.validateGPSData[idx].COLUMN_L2CA_DOPPLER_IS_VALID = true;
                       }
                       this.validateGPSData[idx].COLUMN_CNOL2CA = this.signal[signalCount].cno;
                       this.validateGPSData[idx].COLUMN_L2CA_CNO_IS_VALID = true;

                   }
                   /*
                   else if (measType == MEASTYPE.L5_Q) 
		   {
                       if (this.m_nPseudorangeGps[idx] > 0) 
		       {
                           if ((pseudorange > -1.0) && (pseudorange < 1.0)) 
			   {
                               this.validateGPSData[idx].COLUMN_L5QCA = 0.0;
                               this.validateGPSData[idx].COLUMN_L5QCA_IS_VALID = false;
                           }
                           else 
			   {
                               this.validateGPSData[idx].COLUMN_L5QCA = pseudorange - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_L5QCA_IS_VALID = true;
                           }
                           if (this.signal[signalCount].cphQuality != 0) 
			   {
                               this.validateGPSData[idx].COLUMN_L5QCA_CPHQUALITY = true;
                           }
                           if (this.signal[signalCount].cpValid) 
			   {
                               this.validateGPSData[idx].COLUMN_L5CA = carrier_phase * L5_LAMBDA - this.m_nPseudorangeGps[idx];
                               this.validateGPSData[idx].COLUMN_L5CA_IS_VALID = true;
                           }
                           this.validateGPSData[idx].COLUMN_L5QCNO = this.signal[signalCount].cno;
                           this.validateGPSData[idx].COLUMN_L5DOPPLER = this.signal[signalCount].doppler;
                           this.validateGPSData[idx].COLUMN_L5QCNO_IS_VALID = true;
                           this.validateGPSData[idx].COLUMN_L5DOPPLER_IS_VALID = true;
                       }
                      
                   } */
               }
               /* 
               else if(this.signal[signalCount].constType == "BEIDOU") 
               {
               idx = prn;

               if(this.validateBeidouData[idx] == null) 
               {
               this.validateBeidouData[idx] = new ValidateBeidouData();
               }
                    
               this.validateBeidouData[idx].VALID = true;
               this.validateBeidouData[idx].PRN = prn;
               pseudorange    = this.signal[signalCount].pseudorange;
               carrier_phase  = this.signal[signalCount].carrierPhase;

               this.validateBeidouData[idx].TYPE = measType;


               if ( measType == MEASTYPE.L1_CA) 
               {
               this.validateBeidouData[idx].COLUMN_CA = pseudorange;
               this.validateBeidouData[idx].COLUMN_CA_IS_VALID = true;
               if (this.signal[signalCount].cpValid )
               {
               this.validateBeidouData[idx].COLUMN_L1CA = carrier_phase * L1_LAMBDA - pseudorange;
               this.validateBeidouData[idx].COLUMN_L1CA_IS_VALID = true;
               }

               if ( this.signal[signalCount].valid ) 
               {
               this.m_nPseudorangeBeidou[idx] = pseudorange;
               }

               this.validateBeidouData[idx].COLUMN_CACNO = this.signal[signalCount].cno;
               this.validateBeidouData[idx].COLUMN_L1CADOPPLER = this.signal[signalCount].doppler;
               this.validateBeidouData[idx].COLUMN_CACNO_IS_VALID = true;
               this.validateBeidouData[idx].COLUMN_L1CADOPPLER_IS_VALID = true;
               }
               else if ( measType == MEASTYPE.L1_P)
               {
               if ( this.m_nPseudorangeBeidou[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateBeidouData[idx].COLUMN_P1CA = 0.0;
               this.validateBeidouData[idx].COLUMN_P1CA_IS_VALID = false;
               }
               else
               {
               this.validateBeidouData[idx].COLUMN_P1CA = pseudorange - this.m_nPseudorangeBeidou[idx];
               this.validateBeidouData[idx].COLUMN_P1CA_IS_VALID = true;
               }
               }
               }
               else if ( measType == MEASTYPE.L2_P)
               {
               if ( this.m_nPseudorangeBeidou[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateBeidouData[idx].COLUMN_P2CA = 0.0;
               this.validateBeidouData[idx].COLUMN_P2CA_IS_VALID = false;
               }
               else
               {
               this.validateBeidouData[idx].COLUMN_P2CA = pseudorange - this.m_nPseudorangeBeidou[idx];
               this.validateBeidouData[idx].COLUMN_P2CA_IS_VALID = true;
               }
               if( this.signal[signalCount].cpValid )
               {
               this.validateBeidouData[idx].COLUMN_L2CA = carrier_phase* L2_LAMBDA - this.m_nPseudorangeBeidou[idx];
               this.validateBeidouData[idx].COLUMN_L2CA_IS_VALID = true;
               }
               }
               this.validateBeidouData[idx].COLUMN_P2CNO = this.signal[signalCount].cno;
               this.validateBeidouData[idx].COLUMN_L2PDOPPLER = this.signal[signalCount].doppler;
               this.validateBeidouData[idx].COLUMN_P2CNO_IS_VALID = true;
               this.validateBeidouData[idx].COLUMN_L2PDOPPLER_IS_VALID = true;
               }
               else if ( measType == MEASTYPE.L2_C)
               {
               if ( this.m_nPseudorangeBeidou[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateBeidouData[idx].COLUMN_L2CCA = 0.0;
               this.validateBeidouData[idx].COLUMN_L2CCA_IS_VALID = false;
               }
               else
               {
               this.validateBeidouData[idx].COLUMN_L2CCA = pseudorange - this.m_nPseudorangeBeidou[idx];
               this.validateBeidouData[idx].COLUMN_L2CCA_IS_VALID = true;
               }
               if( this.signal[signalCount].cpValid )
               {
               this.validateBeidouData[idx].COLUMN_L2CCCA = carrier_phase *L2_LAMBDA - this.m_nPseudorangeBeidou[idx];
               this.validateBeidouData[idx].COLUMN_L2CCCA_IS_VALID = true;
               }
               }
               }
               else if ( measType == MEASTYPE.L5_Q )
               {
               if ( this.m_nPseudorangeBeidou[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateBeidouData[idx].COLUMN_L5QCA = 0.0;
               this.validateBeidouData[idx].COLUMN_L5QCA_IS_VALID = false;
               }
               else
               {
               this.validateBeidouData[idx].COLUMN_L5QCA = pseudorange - this.m_nPseudorangeBeidou[idx];
               this.validateBeidouData[idx].COLUMN_L5QCA_IS_VALID = true;
               }

               if( this.signal[signalCount].cpValid )
               {
               this.validateBeidouData[idx].COLUMN_L5CA = carrier_phase *L5_LAMBDA - this.m_nPseudorangeBeidou[idx];
               this.validateBeidouData[idx].COLUMN_L5CA_IS_VALID = true;
               }
               this.validateBeidouData[idx].COLUMN_L5QCNO = this.signal[signalCount].cno;
               this.validateBeidouData[idx].COLUMN_L5DOPPLER = this.signal[signalCount].doppler;
               this.validateBeidouData[idx].COLUMN_L5QCNO_IS_VALID = true;
               this.validateBeidouData[idx].COLUMN_L5DOPPLER_IS_VALID = true;
               }
               }
               }
               else if(this.signal[signalCount].constType == "GALILEO") 
               {
               idx = prn;

               if(this.validateGalileoData[idx] == null) 
               {
               this.validateGalileoData[idx] = new ValidateGalileoData();
               }
                    
               this.validateGalileoData[idx].VALID = true;
               this.validateGalileoData[idx].PRN = prn;
               pseudorange    = this.signal[signalCount].pseudorange;
               carrier_phase  = this.signal[signalCount].carrierPhase;

               this.validateGalileoData[idx].TYPE = measType;


               if ( measType == MEASTYPE.L1_CA) 
               {
               this.validateGalileoData[idx].COLUMN_CA = pseudorange;
               this.validateGalileoData[idx].COLUMN_CA_IS_VALID = true;
               if (this.signal[signalCount].cpValid )
               {
               this.validateGalileoData[idx].COLUMN_L1CA = carrier_phase * L1_LAMBDA - pseudorange;
               this.validateGalileoData[idx].COLUMN_L1CA_IS_VALID = true;
               }

               if ( this.signal[signalCount].valid ) 
               {
               this.m_nPseudorangeGalileo[idx] = pseudorange;
               }

               this.validateGalileoData[idx].COLUMN_CACNO = this.signal[signalCount].cno;
               this.validateGalileoData[idx].COLUMN_L1CADOPPLER = this.signal[signalCount].doppler;
               this.validateGalileoData[idx].COLUMN_CACNO_IS_VALID = true;
               this.validateGalileoData[idx].COLUMN_L1CADOPPLER_IS_VALID = true;
               }
               else if ( measType == MEASTYPE.L1_P)
               {
               if ( this.m_nPseudorangeGalileo[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateGalileoData[idx].COLUMN_P1CA = 0.0;
               this.validateGalileoData[idx].COLUMN_P1CA_IS_VALID = false;
               }
               else
               {
               this.validateGalileoData[idx].COLUMN_P1CA = pseudorange - this.m_nPseudorangeGalileo[idx];
               this.validateGalileoData[idx].COLUMN_P1CA_IS_VALID = true;
               }
               }
               }
               else if ( measType == MEASTYPE.L2_P)
               {
               if ( this.m_nPseudorangeGalileo[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateGalileoData[idx].COLUMN_P2CA = 0.0;
               this.validateGalileoData[idx].COLUMN_P2CA_IS_VALID = false;
               }
               else
               {
               this.validateGalileoData[idx].COLUMN_P2CA = pseudorange - this.m_nPseudorangeGalileo[idx];
               this.validateGalileoData[idx].COLUMN_P2CA_IS_VALID = true;
               }
               if( this.signal[signalCount].cpValid )
               {
               this.validateGalileoData[idx].COLUMN_L2CA = carrier_phase* L2_LAMBDA - this.m_nPseudorangeGalileo[idx];
               this.validateGalileoData[idx].COLUMN_L2CA_IS_VALID = true;
               }
               }
               this.validateGalileoData[idx].COLUMN_P2CNO = this.signal[signalCount].cno;
               this.validateGalileoData[idx].COLUMN_L2PDOPPLER = this.signal[signalCount].doppler;
               this.validateGalileoData[idx].COLUMN_P2CNO_IS_VALID = true;
               this.validateGalileoData[idx].COLUMN_L2PDOPPLER_IS_VALID = true;
               }
               else if ( measType == MEASTYPE.L2_C)
               {
               if ( this.m_nPseudorangeGalileo[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateGalileoData[idx].COLUMN_L2CCA = 0.0;
               this.validateGalileoData[idx].COLUMN_L2CCA_IS_VALID = false;
               }
               else
               {
               this.validateGalileoData[idx].COLUMN_L2CCA = pseudorange - this.m_nPseudorangeGalileo[idx];
               this.validateGalileoData[idx].COLUMN_L2CCA_IS_VALID = true;
               }
               if( this.signal[signalCount].cpValid )
               {
               this.validateGalileoData[idx].COLUMN_L2CCCA = carrier_phase *L2_LAMBDA - this.m_nPseudorangeGalileo[idx];
               this.validateGalileoData[idx].COLUMN_L2CCCA_IS_VALID = true;
               }
               }
               }
               else if ( measType == MEASTYPE.L5_Q )
               {
               if ( this.m_nPseudorangeGalileo[idx] > 0 )
               {
               if ( (pseudorange > -1.0) && (pseudorange < 1.0) )
               {
               this.validateGalileoData[idx].COLUMN_L5QCA = 0.0;
               this.validateGalileoData[idx].COLUMN_L5QCA_IS_VALID = false;
               }
               else
               {
               this.validateGalileoData[idx].COLUMN_L5QCA = pseudorange - this.m_nPseudorangeGalileo[idx];
               this.validateGalileoData[idx].COLUMN_L5QCA_IS_VALID = true;
               }

               if( this.signal[signalCount].cpValid )
               {
               this.validateGalileoData[idx].COLUMN_L5CA = carrier_phase *L5_LAMBDA - this.m_nPseudorangeGalileo[idx];
               this.validateGalileoData[idx].COLUMN_L5CA_IS_VALID = true;
               }
               this.validateGalileoData[idx].COLUMN_L5QCNO = this.signal[signalCount].cno;
               this.validateGalileoData[idx].COLUMN_L5DOPPLER = this.signal[signalCount].doppler;
               this.validateGalileoData[idx].COLUMN_L5QCNO_IS_VALID = true;
               this.validateGalileoData[idx].COLUMN_L5DOPPLER_IS_VALID = true;
               }
               }
               }
               */
           }
           //***********************  GLONASS   *************************/
           else if (measType == MEASTYPE.L1_GLO || measType == MEASTYPE.L2_GLO ||
              measType == MEASTYPE.P1_GLO || measType == MEASTYPE.P2_GLO) 
	      {
               prn = this.signal[signalCount].prn;
               if (this.signal[signalCount].constType == "GLONASS") 
	       {
                   idx = prn - 1;

                   if (this.validateGlnData[idx] == null) 
		   {
                       this.validateGlnData[idx] = new ValidateGlnData();
                       this.validateGlnData[idx].COLUMN_G1C_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_L1C_GLO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_L1C_GLO_CPHQUALITY = false;
                       this.validateGlnData[idx].COLUMN_L1C_GLO_HALFCYCLEADJ = false;
                       this.validateGlnData[idx].COLUMN_L2P_GLO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_L1P_GLO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_G1CCNO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_G1DOPPLER_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_G2C_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_L2_GLO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_L2_GLO_CPHQUALITY = false;
                       this.validateGlnData[idx].COLUMN_G2CCNO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_G2DOPPLER_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_P1_GLO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_P2_GLO_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_P1DOPPLER_IS_VALID = false;
                       this.validateGlnData[idx].COLUMN_P2DOPPLER_IS_VALID = false;
                   }

                   pseudorange = this.signal[signalCount].pseudorange;
                   carrier_phase = this.signal[signalCount].carrierPhase;
                   cn0 = this.signal[signalCount].cno;
                   doppler = this.signal[signalCount].doppler;
                   prValid = this.signal[signalCount].valid;
                   cpValid = this.signal[signalCount].cpValid;
                   dpValid = this.signal[signalCount].dpValid;

                   this.validateGlnData[idx].VALID = true;
                   this.validateGlnData[idx].PRN = prn;
                   this.validateGlnData[idx].TYPE = measType;


                   if (measType == MEASTYPE.L1_GLO) 
		   {
                       this.validateGlnData[idx].COLUMN_G1C = pseudorange;
                       this.validateGlnData[idx].COLUMN_G1C_IS_VALID = prValid;

                       this.validateGlnData[idx].COLUMN_L1C_GLO = (carrier_phase * GLONASS_WAVELENGTHS[FREQTYPE.L1_FREQ][prn - 1] - pseudorange);
                       this.validateGlnData[idx].COLUMN_L1C_GLO_IS_VALID = prValid && cpValid;

                       this.validateGlnData[idx].COLUMN_G1CCNO_IS_VALID = true;
                       this.validateGlnData[idx].COLUMN_G1DOPPLER_IS_VALID = dpValid;

                       if (this.signal[signalCount].cphQuality != 0) 
		       {
                           this.validateGlnData[idx].COLUMN_L1C_GLO_CPHQUALITY = true;
                       }
                       if (this.signal[signalCount].halfCycleAdj != 0) 
		       {
                           this.validateGlnData[idx].COLUMN_L1C_GLO_HALFCYCLEADJ = true;
                       }

                       this.validateGlnData[idx].COLUMN_G1CCNO = cn0;
                       this.validateGlnData[idx].COLUMN_G1DOPPLER = doppler;

                       if (this.signal[signalCount].valid) 
		       {
                           this.m_nPseudorangeGlo[idx] = pseudorange;
                       }
                   }
                   else if (measType == MEASTYPE.L2_GLO) 
		   {
                       this.validateGlnData[idx].COLUMN_G2C_IS_VALID = prValid;
                       this.validateGlnData[idx].COLUMN_L2_GLO_IS_VALID = prValid && cpValid;
                       this.validateGlnData[idx].COLUMN_G2CCNO_IS_VALID = true;
                       this.validateGlnData[idx].COLUMN_G2DOPPLER_IS_VALID = dpValid;

                       this.validateGlnData[idx].COLUMN_G2C = pseudorange - this.m_nPseudorangeGlo[idx];
                       this.validateGlnData[idx].COLUMN_L2_GLO = (carrier_phase * GLONASS_WAVELENGTHS[FREQTYPE.L2_FREQ][prn - 1] - this.m_nPseudorangeGlo[idx]);


                       if (this.signal[signalCount].cphQuality != 0) 
		       {
                           this.validateGlnData[idx].COLUMN_L2_GLO_CPHQUALITY = true;
                       }

                       this.validateGlnData[idx].COLUMN_G2CCNO = cn0;
                       this.validateGlnData[idx].COLUMN_G2DOPPLER = doppler;
                   }
                   else if (measType == MEASTYPE.P1_GLO) 
		   {
                       if (this.m_nPseudorangeGlo[idx] > 0) {
                           this.validateGlnData[idx].COLUMN_P1_GLO_IS_VALID = prValid;
                           this.validateGlnData[idx].COLUMN_L1P_GLO_IS_VALID = prValid && cpValid;
                           this.validateGlnData[idx].COLUMN_L1P_GLO = (carrier_phase * GLONASS_WAVELENGTHS[FREQTYPE.L1_FREQ][prn - 1] - pseudorange);
                           this.validateGlnData[idx].COLUMN_P1_GLO = pseudorange - this.m_nPseudorangeGlo[idx];
                           this.validateGlnData[idx].COLUMN_P1DOPPLER_IS_VALID = dpValid;
                           this.validateGlnData[idx].COLUMN_P1DOPPLER = doppler;
                       }
                   }
                   else if (measType == MEASTYPE.P2_GLO) 
		   {
                       if (this.m_nPseudorangeGlo[idx] > 0) {
                           this.validateGlnData[idx].COLUMN_P2_GLO_IS_VALID = prValid;
                           this.validateGlnData[idx].COLUMN_L2P_GLO_IS_VALID = prValid && cpValid;
                           this.validateGlnData[idx].COLUMN_L2P_GLO = (carrier_phase * GLONASS_WAVELENGTHS[FREQTYPE.L2_FREQ][prn - 1] - pseudorange);
                           this.validateGlnData[idx].COLUMN_P2_GLO = pseudorange - this.m_nPseudorangeGlo[idx];
                           this.validateGlnData[idx].COLUMN_P2DOPPLER_IS_VALID = dpValid;
                           this.validateGlnData[idx].COLUMN_P2DOPPLER = doppler;
                       }
                   }
               }
           }
       }

       //Pass 2: Populate Screen with data
       if (this.validateGPSData != null)
           channel = 0;
       {
           for (idx = 0; idx < COUNT_OF_GPS_ELEMENTS; idx++) 
	   {
               if (this.validateGPSData[idx] != null) {
                   if (this.validateGPSData[idx].VALID == true) 
		   {
                       if (this.gpsDataStore[channel] == null) 
		       {
                           this.gpsDataStore[channel] = new GPSDataStore();
                       }

                       this.gpsDataStore[channel].PRN = null;
                       this.gpsDataStore[channel].COLUMN_L1CA_RANGE = null;
                       this.gpsDataStore[channel].COLUMN_L1CA_PHASE = null;
                       this.gpsDataStore[channel].COLUMN_L1CA_DOPPLER = null;
                       this.gpsDataStore[channel].COLUMN_L1CA_CNO = null;
                       this.gpsDataStore[channel].COLUMN_L1PY_RANGE = null;
                       this.gpsDataStore[channel].COLUMN_L1PY_PHASE = null;
                       this.gpsDataStore[channel].COLUMN_L1PY_DOPPLER = null;
                       this.gpsDataStore[channel].COLUMN_L1PY_CNO = null;
                       this.gpsDataStore[channel].COLUMN_L2CA_RANGE = null;
                       this.gpsDataStore[channel].COLUMN_L2CA_PHASE = null;
                       this.gpsDataStore[channel].COLUMN_L2CA_DOPPLER = null;
                       this.gpsDataStore[channel].COLUMN_L2CA_CNO = null;
                       this.gpsDataStore[channel].COLUMN_L2PY_RANGE = null;
                       this.gpsDataStore[channel].COLUMN_L2PY_PHASE = null;
                       this.gpsDataStore[channel].COLUMN_L2PY_DOPPLER = null;
                       this.gpsDataStore[channel].COLUMN_L2PY_CNO = null;

                       this.gpsDataStore[channel].PRN = this.validateGPSData[idx].PRN;
                       if (this.validateGPSData[idx].COLUMN_L1CA_IS_VALID)
		       {
                           this.gpsDataStore[channel].COLUMN_L1CA_RANGE = this.validateGPSData[idx].COLUMN_RangeL1CA;
                       }
                       if (this.validateGPSData[idx].COLUMN_L1CA_PHASE_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L1CA_PHASE = this.validateGPSData[idx].COLUMN_PhaseL1CA;
                       }
                       if (this.validateGPSData[idx].COLUMN_L1CA_DOPPLER_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L1CA_DOPPLER = this.validateGPSData[idx].COLUMN_DopplerL1CA;
                       }
                       if (this.validateGPSData[idx].COLUMN_L1CA_CNO_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L1CA_CNO = this.validateGPSData[idx].COLUMN_CNOL1CA;
                       }

                       if (this.validateGPSData[idx].COLUMN_L1PY_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L1PY_RANGE = this.validateGPSData[idx].COLUMN_RangeL1PY;
                       }
                       if (this.validateGPSData[idx].COLUMN_L1PY_PHASE_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L1PY_PHASE = this.validateGPSData[idx].COLUMN_PhaseL1PY;
                       }
                       if (this.validateGPSData[idx].COLUMN_L1PY_DOPPLER_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L1PY_DOPPLER = this.validateGPSData[idx].COLUMN_DopplerL1PY;
                       }
                       if (this.validateGPSData[idx].COLUMN_L1PY_CNO_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L1PY_CNO = this.validateGPSData[idx].COLUMN_CNOL1PY;
                       }

                       if (this.validateGPSData[idx].COLUMN_L2CA_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2CA_RANGE = this.validateGPSData[idx].COLUMN_RangeL2CA;
                       }
                       if (this.validateGPSData[idx].COLUMN_L2CA_PHASE_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2CA_PHASE = this.validateGPSData[idx].COLUMN_PhaseL2CA;
                       }
                       if (this.validateGPSData[idx].COLUMN_L2CA_DOPPLER_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2CA_DOPPLER = this.validateGPSData[idx].COLUMN_DopplerL2CA;
                       }
                       if (this.validateGPSData[idx].COLUMN_L2CA_CNO_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2CA_CNO = this.validateGPSData[idx].COLUMN_CNOL2CA;
                       }

                       if (this.validateGPSData[idx].COLUMN_L2PY_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2PY_RANGE = this.validateGPSData[idx].COLUMN_RangeL2PY;
                       }
                       if (this.validateGPSData[idx].COLUMN_L2PY_PHASE_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2PY_PHASE = this.validateGPSData[idx].COLUMN_PhaseL2PY;
                       }
                       if (this.validateGPSData[idx].COLUMN_L2PY_DOPPLER_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2PY_DOPPLER = this.validateGPSData[idx].COLUMN_DopplerL2PY;
                       }
                       if (this.validateGPSData[idx].COLUMN_L2PY_CNO_IS_VALID) 
		       {
                           this.gpsDataStore[channel].COLUMN_L2PY_CNO = this.validateGPSData[idx].COLUMN_CNOL2PY;
                       }
                       channel++;
                   }
               }
           }
       }

       if (this.validateGlnData != null) 
       {
           channel = 0;
           for (idx = 0; idx < COUNT_OF_GLONASS_ELEMENTS; idx++) 
	   {
               if (this.validateGlnData[idx] != null) 
	       {
                   if (this.validateGlnData[idx].VALID == true) 
		   {
                       if (this.glnDataStore[channel] == null) 
		       {
                           this.glnDataStore[channel] = new GLNDataStore();
                       }

                       this.glnDataStore[channel].PRN = this.validateGlnData[idx].PRN;

                       if (this.validateGlnData[idx].COLUMN_G1C_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_G1C = this.validateGlnData[idx].COLUMN_G1C;
                       if (this.validateGlnData[idx].COLUMN_L1C_GLO_IS_VALID) 
		       {
                           this.glnDataStore[channel].GLO_COLUMN_L1C_GLO = this.validateGlnData[idx].COLUMN_L1C_GLO;
                           if (this.validateGlnData[idx].COLUMN_L1C_GLO_CPHQUALITY) 
			   {
                               this.glnDataStore[channel].GLO_COLUMN_L1C_GLO = this.validateGlnData[idx].COLUMN_L1C_GLO;
                           }
                           if (this.validateGlnData[idx].COLUMN_L1C_GLO_HALFCYCLEADJ) 
			   {
                               //TODO: UPDATE THIS AS NECESSARY
                           }
                       }
                       if (this.validateGlnData[idx].COLUMN_L1P_GLO_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_L1P_GLO = this.validateGlnData[idx].COLUMN_L1P_GLO;
                       if (this.validateGlnData[idx].COLUMN_L2P_GLO_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_L2P_GLO = this.validateGlnData[idx].COLUMN_L2P_GLO;
                       if (this.validateGlnData[idx].COLUMN_G1CCNO_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_G1CCNO = this.validateGlnData[idx].COLUMN_G1CCNO;
                       if (this.validateGlnData[idx].COLUMN_G1DOPPLER_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_G1DOPPLER = this.validateGlnData[idx].COLUMN_G1DOPPLER;
                       if (this.validateGlnData[idx].COLUMN_P1DOPPLER_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_P1DOPPLER = this.validateGlnData[idx].COLUMN_P1DOPPLER;
                       if (this.validateGlnData[idx].COLUMN_G2C_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_G2C = this.validateGlnData[idx].COLUMN_G2C;
                       if (this.validateGlnData[idx].COLUMN_L2_GLO_IS_VALID) 
		       {
                           this.glnDataStore[channel].GLO_COLUMN_L2_GLO = this.validateGlnData[idx].COLUMN_L2_GLO;
                           if (this.validateGlnData[idx].COLUMN_L2_GLO_CPHQUALITY) 
			   {
                               //TODO: UPDATE THIS AS NECESSARY
                           }
                       }
                       if (this.validateGlnData[idx].COLUMN_G2CCNO_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_G2CCNO = this.validateGlnData[idx].COLUMN_G2CCNO;
                       if (this.validateGlnData[idx].COLUMN_G2DOPPLER_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_G2DOPPLER = this.validateGlnData[idx].COLUMN_G2DOPPLER;
                       if (this.validateGlnData[idx].COLUMN_P1_GLO_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_P1_GLO = this.validateGlnData[idx].COLUMN_P1_GLO;
                       if (this.validateGlnData[idx].COLUMN_P2_GLO_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_P2_GLO = this.validateGlnData[idx].COLUMN_P2_GLO;
                       if (this.validateGlnData[idx].COLUMN_P2DOPPLER_IS_VALID)
                           this.glnDataStore[channel].GLO_COLUMN_P2DOPPLER = this.validateGlnData[idx].COLUMN_P2DOPPLER;

                       channel++;
                   }
               }
           }
       }
       /*
       if(this.validateSBASData != null) 
       {
       channel = 0;
       for ( idx = 0; idx < COUNT_OF_WAAS_ELEMENTS; idx++ )
       {
       if( this.validateSBASData[idx] != null )
       {
       if (this.validateSBASData[idx].VALID == true)
       {
       this.sbasDataStore[channel].PRN = this.validateSBASData[idx].PRN;

       if (this.validateSBASData[idx].COLUMN_CA_IS_VALID)
       this.sbasDataStore[channel].COLUMN_CA = this.validateSBASData[idx].COLUMN_CA;

       if (this.validateSBASData[idx].COLUMN_L1CA_IS_VALID)
       this.sbasDataStore[channel].COLUMN_L1CA = this.validateSBASData[idx].COLUMN_L1CA;

       if (this.validateSBASData[idx].COLUMN_P1CA_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_P1CA = this.validateSBASData[idx].COLUMN_P1CA;

       if (this.validateSBASData[idx].COLUMN_L5QCA_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_L5QCA = this.validateSBASData[idx].COLUMN_L5QCA;

       if (this.validateSBASData[idx].COLUMN_P2CA_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_P2CA = this.validateSBASData[idx].COLUMN_P2CA;

       if (this.validateSBASData[idx].COLUMN_L2CA_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_L2CA = this.validateSBASData[idx].COLUMN_L2CA;

       if (this.validateSBASData[idx].COLUMN_L2CCA_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_L2CCA = this.validateSBASData[idx].COLUMN_L2CCA;

       if (this.validateSBASData[idx].COLUMN_L2CCCA_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_L2CCCA = this.validateSBASData[idx].COLUMN_L2CCCA;

       if (this.validateSBASData[idx].COLUMN_CACNO_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_CACNO = this.validateSBASData[idx].COLUMN_CACNO;

       if (this.validateSBASData[idx].COLUMN_P2CNO_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_P2CNO = this.validateSBASData[idx].COLUMN_P2CNO;

       if (this.validateSBASData[idx].COLUMN_L1CADOPPLER_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_L1CADOPPLER = this.validateSBASData[idx].COLUMN_L1CADOPPLER;

       if (this.validateSBASData[idx].COLUMN_L2PDOPPLER_IS_VALID) 
       this.sbasDataStore[channel].COLUMN_L2PDOPPLER = this.validateSBASData[idx].COLUMN_L2PDOPPLER;

       if (this.validateSBASData[idx].COLUMN_L5CA_IS_VALID)
       this.sbasDataStore[channel].COLUMN_L5CA = this.validateSBASData[idx].COLUMN_L5CA; 

       if (this.validateSBASData[idx].COLUMN_L5QCNO)
       this.sbasDataStore[channel].COLUMN_L5QCNO = this.validateSBASData[idx].COLUMN_L5QCNO; 

       if (this.validateSBASData[idx].COLUMN_L5DOPPLER_IS_VALID)
       this.sbasDataStore[channel].COLUMN_L5QDOPPLER = this.validateSBASData[idx].COLUMN_L5DOPPLER; 

       channel++;
       }
       }
       }
       }

       if(this.validateGalileoData != null) 
       {
       channel = 0;
       for ( idx = 0; idx < COUNT_OF_GALILEO_ELEMENTS; idx++ )
       {
       if( this.validateGalileoData[idx] != null )
       {
       if (this.validateGalileoData[idx].VALID == true)
       {
       this.galileoDataStore[channel].PRN = this.validateGalileoData[idx].PRN;

       if (this.validateGalileoData[idx].COLUMN_CA_IS_VALID)
       this.galileoDataStore[channel].COLUMN_CA = this.validateGalileoData[idx].COLUMN_CA;

       if (this.validateGalileoData[idx].COLUMN_L1CA_IS_VALID)
       this.galileoDataStore[channel].COLUMN_L1CA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L1CA;

       if (this.validateGalileoData[idx].COLUMN_P1CA_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_P1CA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_P1CA;

       if (this.validateGalileoData[idx].COLUMN_L5QCA_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_L5QCA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L5QCA;

       if (this.validateGalileoData[idx].COLUMN_P2CA_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_P2CA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_P2CA;

       if (this.validateGalileoData[idx].COLUMN_L2CA_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_L2CA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L2CA;

       if (this.validateGalileoData[idx].COLUMN_L2CCA_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_L2CCA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L2CCA;

       if (this.validateGalileoData[idx].COLUMN_L2CCCA_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_L2CCCA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L2CCCA;

       if (this.validateGalileoData[idx].COLUMN_CACNO_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_CACNO = this.validateGalileoData[idx].COLUMN_CA.COLUMN_CACNO;

       if (this.validateGalileoData[idx].COLUMN_P2CNO_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_P2CNO = this.validateGalileoData[idx].COLUMN_CA.COLUMN_P2CNO;

       if (this.validateGalileoData[idx].COLUMN_L1CADOPPLER_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_L1CADOPPLER = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L1CADOPPLER;

       if (this.validateGalileoData[idx].COLUMN_L2PDOPPLER_IS_VALID) 
       this.galileoDataStore[channel].COLUMN_L2PDOPPLER = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L2PDOPPLER;

       if(this.validateGalileoData[idx].COLUMN_L5CA_IS_VALID)
       this.galileoDataStore[channel].COLUMN_L5CA = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L5CA; 

       if(this.validateGalileoData[idx].COLUMN_L5QCNO)
       this.galileoDataStore[channel].COLUMN_L5QCNO = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L5QCNO; 

       if(this.validateGalileoData[idx].COLUMN_L5DOPPLER_IS_VALID)
       this.galileoDataStore[channel].COLUMN_L5QDOPPLER = this.validateGalileoData[idx].COLUMN_CA.COLUMN_L5DOPPLER; 

       channel++;
       }
       }
       }
       }

       if(this.validateBeidouData != null) 
       {
       channel = 0;
       for ( idx = 0; idx < COUNT_OF_BEIDOU_ELEMENTS; idx++ )
       {
       if( this.validateBeidouData[idx] != null )
       {
       if (this.validateBeidouData[idx].VALID == true)
       {
       this.beidouDataStore[channel].PRN = this.validateBeidouData[idx].PRN;

       if(this.validateBeidouData[idx].COLUMN_CA_IS_VALID)
       this.beidouDataStore[channel].COLUMN_CA = this.validateBeidouData[idx].COLUMN_CA;

       if(this.validateBeidouData[idx].COLUMN_L1CA_IS_VALID)
       this.beidouDataStore[channel].COLUMN_L1CA = this.validateBeidouData[idx].COLUMN_L1CA;

       if(this.validateBeidouData[idx].COLUMN_P1CA_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_P1CA = this.validateBeidouData[idx].COLUMN_P1CA;

       if(this.validateBeidouData[idx].COLUMN_L5QCA_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_L5QCA = this.validateBeidouData[idx].COLUMN_L5QCA;

       if(this.validateBeidouData[idx].COLUMN_P2CA_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_P2CA = this.validateBeidouData[idx].COLUMN_P2CA;

       if(this.validateBeidouData[idx].COLUMN_L2CA_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_L2CA = this.validateBeidouData[idx].COLUMN_L2CA;

       if(this.validateBeidouData[idx].COLUMN_L2CCA_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_L2CCA = this.validateBeidouData[idx].COLUMN_L2CCA;

       if(this.validateBeidouData[idx].COLUMN_L2CCCA_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_L2CCCA = this.validateBeidouData[idx].COLUMN_L2CCCA;

       if(this.validateBeidouData[idx].COLUMN_CACNO_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_CACNO = this.validateBeidouData[idx].COLUMN_CACNO;

       if(this.validateBeidouData[idx].COLUMN_P2CNO_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_P2CNO = this.validateBeidouData[idx].COLUMN_P2CNO;

       if(this.validateBeidouData[idx].COLUMN_L1CADOPPLER_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_L1CADOPPLER = this.validateBeidouData[idx].COLUMN_L1CADOPPLER;

       if(this.validateBeidouData[idx].COLUMN_L2PDOPPLER_IS_VALID) 
       this.beidouDataStore[channel].COLUMN_L2PDOPPLER = this.validateBeidouData[idx].COLUMN_L2PDOPPLER;

       if(this.validateBeidouData[idx].COLUMN_L5CA_IS_VALID)
       this.beidouDataStore[channel].COLUMN_L5CA = this.validateBeidouData[idx].COLUMN_L5CA; 

       if(this.validateBeidouData[idx].COLUMN_L5QCNO)
       this.beidouDataStore[channel].COLUMN_L5QCNO = this.validateBeidouData[idx].COLUMN_L5QCNO; 

       if(this.validateBeidouData[idx].COLUMN_L5DOPPLER_IS_VALID)
       this.beidouDataStore[channel].COLUMN_L5QDOPPLER = this.validateBeidouData[idx].COLUMN_L5DOPPLER; 

       channel++;
       }
       }
       }
       }
       */
   } 
}

